#ifndef __PACKET_LAYER_H
#define __PACKET_LAYER_H

#include "base/protocol/Packet.h"
#include "base/network/NetworkInterface.h"
#include <vector>
#include <cassert>

using std::vector;

class PacketLayer {
public:
									PacketLayer				(NetworkInterface& iface);
									~PacketLayer			();

	void							registerAllProtocols	();
	void							unregisterAllProtocols	();
	void							registerProtocol		(Packet::PROTOCOL proto);
	void							unregisterProtocol		(Packet::PROTOCOL proto);
	Packet*							read					();

protected:
	
	typedef vector<unsigned short>	INFILTER_SET;
	INFILTER_SET					m_infilter;
	NetworkInterface&				m_iface;

};

#endif // __PACKET_LAYER_H
