#ifndef __NETWORK_INTERFACE_OMNETPP_H
#define __NETWORK_INTERFACE_OMNETPP_H

#ifdef OMNET_SIMULATION

#include "base/network/NetworkInterface.h"
#include "base/protocol/PacketFactory.h"
#include "base/common/Helper.h"
#include <cmath>
#include <queue>
#include <deque>
#include <boost/thread/mutex.hpp>

#pragma warning (disable : 4244 4800 4267)
#include <omnetpp.h>
#include <IPDatagram.h>
#include <ICMPMessage.h>
#include <TCPSegment.h>
#include <UDPPacket.h>
#pragma warning (default : 4244 4800 4267)

using std::queue;
using std::deque;

class FrameDistribution; // forward decl

class NetworkInterfaceOmnetpp : public NetworkInterface {
public:
							NetworkInterfaceOmnetpp			();
							~NetworkInterfaceOmnetpp		();

	void					setFrameDistribution			(FrameDistribution* distrib);

	//
	// functions from NetworkInterface inheritance
	//

	bool					open							();
	bool					close							();
	Frame*					read							();

	friend class			DistackOmnetModule;	

private:

	void					handleMessage					(cMessage* msg);
	void					handleProtocolMessage			(cMessage* msg);

	Frame*					convertOmnetToDistack			(cMessage* message);	
	Packet*					convertMessage					(IPDatagram* msg);
	Packet*					convertMessage					(TCPSegment* msg);
	Packet*					convertMessage					(UDPPacket* msg);
	Packet*					convertMessage					(ICMPMessage* msg);

	FrameDistribution*		frameDistribution;

};

#endif // OMNET_SIMULATION
#endif // __NETWORK_INTERFACE_OMNETPP_H
