#ifndef __MESSAGE_ADDRESS_DISTRIBUTION_H
#define __MESSAGE_ADDRESS_DISTRIBUTION_H

#include "base/message/Message.h"
#include "base/common/SubnetCounterTree.h"
#include <vector>
#include <algorithm>

using std::vector;

class MessageAddressDistribution : public Message {
public:
					MessageAddressDistribution		();				
					~MessageAddressDistribution		();

	MESSAGE_TYPE			getType					();

	void				addSubnetDistrib			(SubnetCounterTree* tree);
	unsigned int			getSubnetDistribCount			();
	SubnetCounterTree*		getSubnetDistrib			(unsigned int index);

private:

	typedef vector<SubnetCounterTree*>					SUBNET_COUNTER_ITEMS;
	typedef SUBNET_COUNTER_ITEMS::iterator					SUBNET_COUNTER_ITEMS_ITERATOR;
	SUBNET_COUNTER_ITEMS								m_counterItems;

	// TODO:
	//REMOTE_MESSAGING_BEGIN(MessageAddressDistribution, remote)
	//REMOTE_MESSAGING_END

};

#endif // __MESSAGE_ADDRESS_DISTRIBUTION_H
